#ifndef __QBUFFER_H
#define __QBUFFER_H

#include "qiodevice.h"

class QByteArray
{
 protected:
  const char * m_Buffer;
  int m_nSize;
 public:
  QByteArray () { m_Buffer = 0; m_nSize =0 ;}
  QByteArray(const QByteArray & a)
    {
      assign(a.buffer(),a.length());
    }
  QByteArray & assign(const char * a, unsigned int n) 
    { 
      m_Buffer = new char [n];
      memcpy((char*)m_Buffer,a,n);
      m_nSize = n;
      return *this; 
    }
  int length() const { return m_nSize; }
  const char * buffer() const { return m_Buffer; }
};

class QBuffer : public QIODevice
{
  QByteArray m_Buffer;
 public:
  QBuffer() { }
  virtual int readBlock(char * data, uint maxlen)
    {
      memcpy(data,m_Buffer.buffer(),maxlen);

    }
  virtual int writeBlock( const char * data, unsigned int len)
    {
      m_Buffer.assign(data,len);
    }
  QByteArray buffer() const { return m_Buffer; }
};



#endif
