#include "qpixmap.h"
#include "Fl_Image.H"
#include "fl_draw.H"
#include <Imlib.h>

extern Display * fl_display;

static ImlibData * m_id;
extern Window fl_window;

bool QPixmap::m_bInitialized;

bool QPixmap::loadFromData( const QByteArray & data, const char * format,
			    int conversion_flags)
{
   // This is a bit of a hack
  char namebuf[1024];
  tmpnam(namebuf);
  FILE * ptr;
  bool ret;

  ptr=fopen(namebuf,"w");

  if(ptr==NULL) {
    cerr << "Couldn't make temporary file for QPixmap::loadFromData!\n";
    return false;
  }

  unsigned int loopc;

  char * buf = data.buffer();

  for(loopc=0;loopc<data.length();loopc++) {
    fputc(buf[loopc],ptr);
  }

  fclose(ptr);
  ret=load(namebuf);

  //  Delete the file
  unlink(namebuf);
  return ret;
}

bool QPixmap::load ( const QString & fileName, 
		     const char * format, ColorMode mode )
{
  if(!m_bInitialized) {
    m_id = Imlib_init(fl_display);
    if(!m_id)
      return false;
    m_bInitialized = 1;
  }

  ImlibImage * im;
  im=Imlib_load_image(m_id,(char *)fileName);
  
  m_IM = im;

  if(im==0) {
    cerr << "Errk! Failed to load QPixmap " << fileName << "\n";
    return false;
  }
  m_nPix_W = m_nWidth = im->rgb_width;
  m_nPix_H = m_nHeight = im->rgb_height;

  // Remove old image if there is one
  if(m_Pixmap) {
    Imlib_free_pixmap(m_id,(Pixmap)m_Pixmap);
  }
  Imlib_render(m_id,im,m_nPix_W,m_nPix_H);
  
  m_Pixmap = (unsigned long)Imlib_move_image(m_id,im);
  m_Mask = (unsigned long)Imlib_move_mask(m_id,im);
  //  Imlib_destroy_image(m_id,im);
  return true;
}

void QPixmap::drawPixmap(const QPoint & point, const QRect & rect)
{
  int x = (parent() ?  parent()->x() + point.x() : point.x())-1;
  int y = (parent() ?  parent()->y() + point.y() : point.y())-1;

  Imlib_paste_image(m_id, m_IM, fl_window,
		    x,y,rect.width(),rect.height());
}
